
#import "AppController.h"

#import "PreferenceController.h"
#import "BWMinuteTimer.h"



@implementation AppController


// We've been loaded from the main nib.  Time to set up housekeeping

- (void) awakeFromNib
{
    // get our preferences engine up and running

    preferenceController = [[PreferenceController alloc] init];

    // start our heartbeat

    timer = [BWMinuteTimer scheduleTimerWithTarget: self
			   selector: @selector(checkTime:)
			   userInfo: nil];

    [timer retain];

} // awakeFromNib




// our heartbeat timer calls this once a minute.  Compare the current
// minute with the list of times to pop up alerts (gotten via the
// pref controller)

- (void) checkTime: (BWMinuteTimer *)timer
{
    int minutes;
    NSNumber *number;
    NSSet *alertTimes = [preferenceController alertTimes];
    NSString *messageText = [preferenceController alertMessage];

    {
	char ook[1024];
	struct tm *tm;
	time_t clock = time (NULL);

	tm = localtime(&clock);
	strftime (ook, 1024, "%M", tm); // get the minutes of the hour
	minutes = atoi (ook);
    }
    
    number = [NSNumber numberWithInt: minutes];

    // whee!! time to put up the alert!
    if ([alertTimes containsObject: number]) {
	[NSApp activateIgnoringOtherApps: YES];
	[message setStringValue: messageText];
	[window center];
	[window makeKeyAndOrderFront: nil];
    }

} // checkTime




// put up the preference panel

- (IBAction) showPreferencePanel: (id) sender
{
    [preferenceController showWindow: self];

} // showPreferencePanel




// the OK button on the alert window uses this to close the winder

- (IBAction) closeWindow: (id) sender
{
    [window close];

} // closeWindow


@end // AppController


